module Globs
  class ExtGlob

    MATCH_REGEXP = /(\\).|([@?!+*]\(.*\))/

    def initialize(glob)
      @glob = glob
    end

    def valid?


      return false unless @glob && @glob.kind_of?(String) && @glob != "" 

      glob = @glob.dup

      while(match = MATCH_REGEXP.match(glob)) do 
        return true if match[2]
        
  
        glob.slice!(match.begin(0), match[0].length)

     

      end

      false
    end
  end

end