
require "sftp/sync/config"


module Sftp
  module Sync
    class Runner

      def initialize(options = {})
        @config = Config.new(options)
      end



      def list
        client = Sftp::Sync::Client.new(@config)

        client.list
      end


      def pull
        client = Sftp::Sync::Client.new(@config)

        client.pull
      end



      def diff
        client = Sftp::Sync::Client.new(@config)

        client.diff
      end

    end
  end



end